<template>
  <v-data-table
    v-model="model"
    :items="items"
    :headers="headers"
    :density="density"
    :items-per-page="itemsPerPage"
    :item-value="itemValue"
    :loading="loading"
    :show-select="showSelect"
    @update:model-value="updateModelValue"
  >
    <template #item="{ item, index }">
      <slot name="item" :item="item" :index="index" />
    </template>

    <template #loading>
      <slot name="loading" />
    </template>

    <template #no-data>
      <slot name="no-data" />
    </template>

    <template #bottom>
      <svn-pro-pagination
        v-if="paginationTotalPages > 1"
        :page="currentPage"
        :length="paginationTotalPages"
        class="mt-6"
        @update:model-value="updatePagination"
      />
    </template>
  </v-data-table>
</template>

<script setup>
import { ref, watch, onMounted } from 'vue';
import SvnProPagination from '../pagination/SvnProPagination.vue';

const props = defineProps({
  modelValue:{
    type: undefined,
    default: null,
  },
  items: {
    type: Array,
    default: () => [],
  },
  headers: {
    type: Array,
    default: () => [],
  },
  density: {
    type: String,
    default: "default",
  },
  itemValue: {
    type: String,
    default: "title",
  },
  loading: {
    type: Boolean,
    default: false,
  },
  showSelect: {
    type: Boolean,
    default: false,
  },
  page: {
    type: Number,
    default: 1,
  },
  itemsPerPage: {
    type: Number,
    default: 1,
  },
  paginationTotalPages: {
    type: Number,
    default: 1
  },
})

const emit = defineEmits(['update:modelValue', 'update-pagination'])

onMounted(() => {
  model.value = props?.modelValue
});

const model = ref(null);
const currentPage = ref(props?.page);

const updateModelValue = () => {
  emit('update:modelValue', model?.value)
}

const updatePagination = (page) => {
  emit('update-pagination', page)
}

watch(props, (newValue, oldValue) => {
  if (newValue.modelValue) {
    model.value = newValue.modelValue
  }
  if (newValue.page) {
    currentPage.value = newValue.page
  }
})
</script>